--- //depot/vendor/freebsd/src/sys/kern/uipc_socket2.c	2005/07/01 16:35:11
+++ //depot/user/rwatson/netperf/sys/kern/uipc_socket2.c	2005/07/05 14:55:33
@@ -106,11 +106,22 @@
 {
 
 	SOCK_LOCK(so);
+	/*
+	 * XXXRW: so_state locking?
+	 *
+	 * XXXRW: Why not clear SS_ISDISCONNECTED, SS_ISCONFIRMING?
+	 */
 	so->so_state &= ~(SS_ISCONNECTED|SS_ISDISCONNECTING);
 	so->so_state |= SS_ISCONNECTING;
 	SOCK_UNLOCK(so);
 }
 
+/*
+ * soisconnected() transitions a socket to a fully connected state.  If
+ * so->so_head is non-NULL, we transition it from the incompletely
+ * connected queue to the completely connected queue.  Otherwise, we
+ * just wake up the socket since it was an out-bound connection.
+ */
 void
 soisconnected(so)
 	struct socket *so;
@@ -121,6 +132,12 @@
 	SOCK_LOCK(so);
 	so->so_state &= ~(SS_ISCONNECTING|SS_ISDISCONNECTING|SS_ISCONFIRMING);
 	so->so_state |= SS_ISCONNECTED;
+
+	/*
+	 * XXXRW: Maybe an unlocked read of so_head would be desirable
+	 * here?  Unlocked read of so_qstate probably not a good idea
+	 * regardless.  so_options handling here is a little unsavory.
+	 */
 	head = so->so_head;
 	if (head != NULL && (so->so_qstate & SQ_INCOMP)) {
 		if ((so->so_options & SO_ACCEPTFILTER) == 0) {
@@ -135,14 +152,36 @@
 			sorwakeup(head);
 			wakeup_one(&head->so_timeo);
 		} else {
+			void (*so_upcall)(struct socket *, void *, int);
+			void *so_upcallarg;
 			ACCEPT_UNLOCK();
-			so->so_upcall =
+			/*
+			 * XXXRW: Should probably copy the upcall fields to
+			 * local stack variables while holding the socket
+			 * lock (and clear the option), then release the
+			 * lock and make the call.  This will prevent lock
+			 * order reversals/recursion between this code and
+			 * the upcall implementation, which will likely
+			 * also want to frob the socket using locks.
+			 *
+			 * NOTE: We keep a local copy of the function
+			 * pointer so we can invoke the upcall without
+			 * holding locks.  However, we also have to copy
+			 * in the upcall fields from the head because the
+			 * filter may need to be called more than once.
+			 */
+			so_upcall = so->so_upcall =
 			    head->so_accf->so_accept_filter->accf_callback;
-			so->so_upcallarg = head->so_accf->so_accept_filter_arg;
+			so_upcallarg = so->so_upcallarg =
+			    head->so_accf->so_accept_filter_arg;
 			so->so_rcv.sb_flags |= SB_UPCALL;
 			so->so_options &= ~SO_ACCEPTFILTER;
 			SOCK_UNLOCK(so);
-			so->so_upcall(so, so->so_upcallarg, M_DONTWAIT);
+			/*
+			 * Call with our existing reference, but without
+			 * any locks.
+			 */
+			so_upcall(so, so_upcallarg, M_DONTWAIT);
 		}
 		return;
 	}
@@ -226,6 +265,8 @@
 	so->so_type = head->so_type;
 	so->so_options = head->so_options &~ SO_ACCEPTCONN;
 	so->so_linger = head->so_linger;
+	/* XXXRW: so_state locking? */
+	/* XXXRW: should mask additional head->so_state bits here? */
 	so->so_state = head->so_state | SS_NOFDREF;
 	so->so_proto = head->so_proto;
 	so->so_timeo = head->so_timeo;
@@ -402,6 +443,10 @@
 	}
 	KNOTE_LOCKED(&sb->sb_sel.si_note, 0);
 	SOCKBUF_UNLOCK(sb);
+	/*
+	 * XXXRW: What locks should be held over what parts of the
+	 * following?  Currently we hold none.
+	 */
 	if ((so->so_state & SS_ASYNC) && so->so_sigio != NULL)
 		pgsigio(&so->so_sigio, SIGIO, 0);
 	if (sb->sb_flags & SB_UPCALL)
@@ -448,7 +493,7 @@
 	register struct socket *so;
 	u_long sndcc, rcvcc;
 {
-	struct thread *td = curthread;
+	struct thread *td = curthread;		/* XXX */
 
 	SOCKBUF_LOCK(&so->so_snd);
 	SOCKBUF_LOCK(&so->so_rcv);
@@ -512,6 +557,13 @@
 	/*
 	 * td will only be NULL when we're in an interrupt
 	 * (e.g. in tcp_input())
+	 *
+	 * XXXRW: This comment is true, but only because the caller passed
+	 * in NULL, not for the 4.x reason that there is no thread
+	 * available.  Need to be careful of callers that do this wrong;
+	 * I suspect many do it wrong, and therefore many socket buffers
+	 * end up with the wrong limits, especially via the soreserve()
+	 * path.
 	 */
 	if (cc > sb_max_adj)
 		return (0);
@@ -1442,6 +1494,7 @@
 	xso->so_type = so->so_type;
 	xso->so_options = so->so_options;
 	xso->so_linger = so->so_linger;
+	/* Unlocked read. */
 	xso->so_state = so->so_state;
 	xso->so_pcb = so->so_pcb;
 	xso->xso_protocol = so->so_proto->pr_protocol;
--- //depot/vendor/freebsd/src/sys/kern/uipc_syscalls.c	2005/07/05 22:50:36
+++ //depot/user/rwatson/netperf/sys/kern/uipc_syscalls.c	2005/07/19 11:47:08
@@ -317,6 +317,7 @@
 	error = fgetsock(td, uap->s, &head, &fflag);
 	if (error)
 		goto done2;
+	/* Unlocked read. */
 	if ((head->so_options & SO_ACCEPTCONN) == 0) {
 		error = EINVAL;
 		goto done;
@@ -331,6 +332,10 @@
 	error = falloc(td, &nfp, &fd);
 	if (error)
 		goto done;
+	/*
+	 * Unlocked reads.
+	 * XXXRW: Dubious use of so->so_error.
+	 */
 	ACCEPT_LOCK();
 	if ((head->so_state & SS_NBIO) && TAILQ_EMPTY(&head->so_comp)) {
 		ACCEPT_UNLOCK();
@@ -379,6 +384,11 @@
 	/* An extra reference on `nfp' has been held for us by falloc(). */
 	td->td_retval[0] = fd;
 
+	/*
+	 * XXXRW: Might make life simpler to grab the socket buffer lock
+	 * here so it's held when KNOTE() calls back into the socket
+	 * code.
+	 */
 	/* connection has been removed from the listen queue */
 	KNOTE_UNLOCKED(&head->so_rcv.sb_sel.si_note, 0);
 
@@ -522,6 +532,7 @@
 	if (error)
 		goto done2;
 	so = fp->f_data;
+	/* XXXRW: so_state locking? */
 	if (so->so_state & SS_ISCONNECTING) {
 		error = EALREADY;
 		goto done1;
@@ -536,11 +547,13 @@
 	error = soconnect(so, sa, td);
 	if (error)
 		goto bad;
+	/* XXXRW: so_state locking? */
 	if ((so->so_state & SS_NBIO) && (so->so_state & SS_ISCONNECTING)) {
 		error = EINPROGRESS;
 		goto done1;
 	}
 	SOCK_LOCK(so);
+	/* XXXRW: so_state locking? */
 	while ((so->so_state & SS_ISCONNECTING) && so->so_error == 0) {
 		error = msleep(&so->so_timeo, SOCK_MTX(so), PSOCK | PCATCH,
 		    "connec", 0);
@@ -556,6 +569,7 @@
 	}
 	SOCK_UNLOCK(so);
 bad:
+	/* XXXRW: so_state locking? */
 	if (!interrupted)
 		so->so_state &= ~SS_ISCONNECTING;
 	if (error == ERESTART)
@@ -1534,6 +1548,7 @@
 	if (error)
 		goto done2;
 	so = fp->f_data;
+	/* XXXRW: so_state locking? */
 	if ((so->so_state & (SS_ISCONNECTED|SS_ISCONFIRMING)) == 0) {
 		error = ENOTCONN;
 		goto done1;
@@ -1775,6 +1790,7 @@
 		error = EINVAL;
 		goto done;
 	}
+	/* XXXRW: so_state locking? */
 	if ((so->so_state & SS_ISCONNECTED) == 0) {
 		error = ENOTCONN;
 		goto done;
@@ -1867,6 +1883,7 @@
 		 * before going to the extra work of constituting the sf_buf.
 		 */
 		SOCKBUF_LOCK(&so->so_snd);
+		/* XXXRW: so_state locking? */
 		if ((so->so_state & SS_NBIO) && sbspace(&so->so_snd) <= 0) {
 			if (so->so_snd.sb_state & SBS_CANTSENDMORE)
 				error = EPIPE;
@@ -1931,6 +1948,7 @@
 			 * Get the page from backing store.
 			 */
 			bsize = vp->v_mount->mnt_stat.f_iosize;
+			mtx_lock(&Giant);	/* VFS */
 			vn_lock(vp, LK_SHARED | LK_RETRY, td);
 			/*
 			 * XXXMAC: Because we don't have fp->f_cred here,
@@ -1942,6 +1960,7 @@
 			    IO_VMIO | ((MAXBSIZE / bsize) << IO_SEQSHIFT),
 			    td->td_ucred, NOCRED, &resid, td);
 			VOP_UNLOCK(vp, 0, td);
+			mtx_unlock(&Giant);	/* VFS */
 			VM_OBJECT_LOCK(obj);
 			vm_page_lock_queues();
 			vm_page_io_finish(pg);
@@ -2052,6 +2071,7 @@
 		 * after checking the connection state above in order to avoid
 		 * a race condition with sbwait().
 		 */
+		/* XXXRW: so_state locking? */
 		if (sbspace(&so->so_snd) < so->so_snd.sb_lowat) {
 			if (so->so_state & SS_NBIO) {
 				m_freem(m);
--- //depot/vendor/freebsd/src/sys/kern/uipc_usrreq.c	2005/05/07 00:45:19
+++ //depot/user/rwatson/netperf/sys/kern/uipc_usrreq.c	2005/06/01 10:10:04
@@ -181,6 +181,9 @@
 {
 	struct unpcb *unp = sotounpcb(so);
 
+	/*
+	 * XXXRW: How could unp be non-NULL here?
+	 */
 	if (unp != NULL)
 		return (EISCONN);
 	return (unp_attach(so));
@@ -355,6 +358,14 @@
 		(void)chgsbsize(so2->so_cred->cr_uidinfo, &so2->so_snd.sb_hiwat,
 		    newhiwat, RLIM_INFINITY);
 		unp->unp_cc = so->so_rcv.sb_cc;
+
+		/*
+		 * XXXRW: It would be desirable to release the UNP lock
+		 * before doing the socket wakeup.  However, to do that we
+		 * need to acquire a reference to so2 so it doesn't evaporate
+		 * if the peer closes it; this may be more expensive than the
+		 * wakeup causing contention on the socket mutex.
+		 */
 		SOCKBUF_UNLOCK(&so->so_rcv);
 		sowwakeup_locked(so2);
 		break;
@@ -377,6 +388,12 @@
 	struct socket *so2;
 	u_long newhiwat;
 
+	/*
+	 * XXXRW: We do the basic checks before acquiring the UNP lock in
+	 * order to avoid paying the cost if it's not needed.  We have to
+	 * re-do the sotounpcb() call once we do acquire it since that may
+	 * have changed.
+	 */
 	unp = sotounpcb(so);
 	if (unp == NULL) {
 		error = EINVAL;
@@ -444,6 +461,7 @@
 		 * Note: A better implementation would complain
 		 * if not equal to the peer's address.
 		 */
+		/* Unlocked read. */
 		if ((so->so_state & SS_ISCONNECTED) == 0) {
 			if (nam != NULL) {
 				error = unp_connect(so, nam, td);
@@ -477,6 +495,9 @@
 		 * Send to paired receive port, and then reduce
 		 * send buffer hiwater marks to maintain backpressure.
 		 * Wake up readers.
+		 *
+		 * XXXRW: Does it matter that we don't check return value of
+		 * sbappend_locked() here?
 		 */
 		if (control != NULL) {
 			if (sbappendcontrol_locked(&so2->so_rcv, m, control))
@@ -538,6 +559,7 @@
 	sb->st_blksize = so->so_snd.sb_hiwat;
 	if (so->so_type == SOCK_STREAM && unp->unp_conn != NULL) {
 		so2 = unp->unp_conn->unp_socket;
+		/* Unlocked read. */
 		sb->st_blksize += so2->so_rcv.sb_cc;
 	}
 	sb->st_dev = NODEV;
@@ -758,6 +780,7 @@
 	so->so_pcb = unp;
 
 	UNP_LOCK();
+	KASSERT(so->so_pcb == NULL, ("unp_attach(): so->so_pcb != NULL"));
 	unp->unp_gencnt = ++unp_gencnt;
 	unp_count++;
 	LIST_INSERT_HEAD(so->so_type == SOCK_DGRAM ? &unp_dhead
@@ -894,6 +917,12 @@
 	ASSERT_VOP_LOCKED(vp, "unp_bind");
 	soun = (struct sockaddr_un *)sodupsockaddr(nam, M_WAITOK);
 	UNP_LOCK();
+	/*
+	 * XXXRW: we actually need to retest unp here and make sure that we
+	 * didn't race with another thread operating on this socket.  In
+	 * particular, we must check unp != NULL, and that unp->unp_vnode ==
+	 * NULL.
+	 */
 	vp->v_socket = unp->unp_socket;
 	unp->unp_vnode = vp;
 	unp->unp_addr = soun;
@@ -949,6 +978,11 @@
 		goto bad;
 	mtx_unlock(&Giant);
 	UNP_LOCK();
+	/*
+	 * XXXRW: We actually need to retest our assumptions here to make
+	 * sure we didn't race with another thread operating on this UNIX
+	 * domain socket.  In particular, that unp != NULL.
+	 */
 	unp = sotounpcb(so);
 	if (unp == NULL) {
 		error = EINVAL;
@@ -970,6 +1004,10 @@
 			 *     w/o locks; this avoids a recursive lock
 			 *     of the head and holding sleep locks across
 			 *     a (potentially) blocking malloc.
+			 *
+			 * XXXRW: This may introduce potential races if
+			 * close() is called on (so) while the lock is
+			 * releasd.
 			 */
 			UNP_UNLOCK();
 			so3 = sonewconn(so2, 0);
@@ -1678,6 +1716,9 @@
 				 * of a signal.  If sbwait does return
 				 * an error, we'll go into an infinite
 				 * loop.  Delete all of this for now.
+				 *
+				 * XXXRW: We will need to lock the socket
+				 * buffer here if we enable this code.
 				 */
 				(void) sbwait(&so->so_rcv);
 				goto restart;
@@ -1689,6 +1730,9 @@
 			 * to see if we hold any file descriptors in its
 			 * message buffers. Follow those links and mark them
 			 * as accessible too.
+			 *
+			 * XXXRW: We hold the socket buffer lock to prevent
+			 * the mbuf chain of interest from changing.
 			 */
 			SOCKBUF_LOCK(&so->so_rcv);
 			unp_scan(so->so_rcv.sb_mb, unp_mark);
--- //depot/vendor/freebsd/src/sys/kern/vfs_aio.c	2005/07/01 16:35:11
+++ //depot/user/rwatson/netperf/sys/kern/vfs_aio.c	2005/07/05 14:55:33
@@ -170,6 +170,9 @@
 SYSCTL_INT(_vfs_aio, OID_AUTO, max_buf_aio, CTLFLAG_RW, &max_buf_aio, 0,
     "Maximum buf aio requests per process (stored in the process)");
 
+/*
+ * struct aiocblist describes a specific AIO I/O request (job).
+ */
 struct aiocblist {
 	TAILQ_ENTRY(aiocblist) list;	/* List of jobs */
 	TAILQ_ENTRY(aiocblist) plist;	/* List of jobs for proc */
@@ -196,6 +199,10 @@
  */
 #define AIOP_FREE	0x1			/* proc on free queue */
 
+/*
+ * struct aiothreadlist is the per-worker thread data structure, and is
+ * allocated by the thread when it is created.
+ */
 struct aiothreadlist {
 	int aiothreadflags;			/* AIO proc flags */
 	TAILQ_ENTRY(aiothreadlist) list;	/* List of processes */
@@ -218,7 +225,9 @@
 #define	LIOJ_SIGNAL_POSTED	0x2	/* signal has been posted */
 
 /*
- * per process aio data structure
+ * struct kaiinfo is the per-process aio data structure.  This is allocated
+ * and hung off of p->p_aioinfo by aio_init_aioinfo() the first time a
+ * process makes use of the AIO facility.
  */
 struct kaioinfo {
 	int	kaio_flags;		/* per process kaio flags */
@@ -1212,6 +1221,8 @@
 
 /*
  * Wake up aio requests that may be serviceable now.
+ *
+ * XXXRW: This doesn't look MPSAFE at all.
  */
 static void
 aio_swake_cb(struct socket *so, struct sockbuf *sb)
--- //depot/vendor/freebsd/src/sys/net/bpf.c	2005/07/01 16:35:11
+++ //depot/user/rwatson/netperf/sys/net/bpf.c	2005/07/05 14:55:33
@@ -294,6 +294,10 @@
 	struct bpf_if *bp;
 	struct ifnet *ifp;
 
+	/*
+	 * XXXRW: Watch out for bpfdetach() in the other direction: can
+	 * d->bd_bif become NULL here?
+	 */
 	bp = d->bd_bif;
 	BPFIF_LOCK(bp);
 	BPFD_LOCK(d);
@@ -317,6 +321,9 @@
 	/*
 	 * Check if this descriptor had requested promiscuous mode.
 	 * If so, turn it off.
+	 *
+	 * XXXRW: Note, ifp might be stale here if the ifnet has been
+	 * removed via bpfdetach().
 	 */
 	if (d->bd_promisc) {
 		d->bd_promisc = 0;
@@ -365,7 +372,6 @@
 		make_dev(&bpf_cdevsw, minor(dev), UID_ROOT, GID_WHEEL, 0600,
 		    "bpf%d", dev2unit(dev));
 	MALLOC(d, struct bpf_d *, sizeof(*d), M_BPF, M_WAITOK | M_ZERO);
-	dev->si_drv1 = d;
 	d->bd_bufsize = bpf_bufsize;
 	d->bd_sig = SIGIO;
 	d->bd_seesent = 1;
@@ -376,6 +382,7 @@
 	mtx_init(&d->bd_mtx, devtoname(dev), "bpf cdev lock", MTX_DEF);
 	callout_init(&d->bd_callout, NET_CALLOUT_MPSAFE);
 	knlist_init(&d->bd_sel.si_note, &d->bd_mtx, NULL, NULL, NULL);
+	dev->si_drv1 = d;
 
 	return (0);
 }
@@ -394,6 +401,9 @@
 {
 	struct bpf_d *d = dev->si_drv1;
 
+	/*
+	 * XXXRW: Should this be a drain not just a callout?
+	 */
 	BPFD_LOCK(d);
 	if (d->bd_state == BPF_WAITING)
 		callout_stop(&d->bd_callout);
@@ -521,6 +531,9 @@
 	 * Move data from hold buffer into user space.
 	 * We know the entire buffer is transferred since
 	 * we checked above that the read buffer is bpf_bufsize bytes.
+	 *
+	 * XXXRW: What protects bd_hbuf and bd_hlen from changing during this
+	 * operation?  Especially given that uiomove() can page fault.
 	 */
 	error = uiomove(d->bd_hbuf, d->bd_hlen, uio);
 
@@ -555,6 +568,10 @@
 	KNOTE_LOCKED(&d->bd_sel.si_note, 0);
 }
 
+/*
+ * XXXRW: What about races against bpf_timed_out() in close?  Need to ensure
+ * that (d) is still valid.
+ */
 static void
 bpf_timed_out(arg)
 	void *arg;
@@ -582,6 +599,11 @@
 	int error;
 	struct sockaddr dst;
 
+	/*
+	 * XXXRW: Need to hold some sort of lock here to prevent races with a
+	 * change of bd_bif?  We might want to cache a bunch of these values
+	 * locally so we don't keep dereferencing (d).
+	 */
 	if (d->bd_bif == NULL)
 		return (ENXIO);
 
@@ -606,6 +628,10 @@
 	mac_create_mbuf_from_bpfdesc(d, m);
 	BPFD_UNLOCK(d);
 #endif
+	/*
+	 * XXXRW: How do we know that (ifp) is still valid here, and also
+	 * still the right type and same interface we had before?
+	 */
 	NET_LOCK_GIANT();
 	error = (*ifp->if_output)(ifp, m, &dst, NULL);
 	NET_UNLOCK_GIANT();
@@ -668,6 +694,10 @@
 	struct bpf_d *d = dev->si_drv1;
 	int error = 0;
 
+	/*
+	 * XXXRW: This is a bit odd.  Does this properly account for possible
+	 * multiple simultaenous access from more than one thread/process?
+	 */
 	BPFD_LOCK(d);
 	if (d->bd_state == BPF_WAITING)
 		callout_stop(&d->bd_callout);
@@ -701,6 +731,10 @@
 		{
 			struct ifnet *ifp;
 
+			/*
+			 * XXXRW: need to make sure ther interface doesn't
+			 * change during this operation?
+			 */
 			if (d->bd_bif == NULL)
 				error = EINVAL;
 			else {
@@ -721,6 +755,11 @@
 	 * Set buffer length.
 	 */
 	case BIOCSBLEN:
+		/*
+		 * XXXRW: Probably ought to hold a mutex over the test of
+		 * bd_bif and the set of bd_bufsize to prevent test-and-set
+		 * races.
+		 */
 		if (d->bd_bif != NULL)
 			error = EINVAL;
 		else {
@@ -754,6 +793,12 @@
 	 * Put interface into promiscuous mode.
 	 */
 	case BIOCPROMISC:
+		/*
+		 * XXXRW: Some atomic test-and-set issues here -- need to
+		 * prevent bd_bif changing simultaneously, as well as deal
+		 * with the call to ifpromisc() safely.  Can ifpromisc()
+		 * sleep?
+		 */
 		if (d->bd_bif == NULL) {
 			/*
 			 * No interface attached yet.
@@ -774,6 +819,10 @@
 	 * Get current data link type.
 	 */
 	case BIOCGDLT:
+		/*
+		 * XXXRW: Need to hold a mutex over test and then use of
+		 * bd_bif.
+		 */
 		if (d->bd_bif == NULL)
 			error = EINVAL;
 		else
@@ -784,6 +833,10 @@
 	 * Get a list of supported data link types.
 	 */
 	case BIOCGDLTLIST:
+		/*
+		 * XXXRW: Need to hold a mutex over test of bd_bif and then
+		 * pass into bpf_getdltlist() to prevent races on bd_bif?
+		 */
 		if (d->bd_bif == NULL)
 			error = EINVAL;
 		else
@@ -794,6 +847,10 @@
 	 * Set data link type.
 	 */
 	case BIOCSDLT:
+		/*
+		 * XXXRW: Need to hold a mutex over test of bd_bif and then
+		 * pass into bpf_setfltlist() to prevent races on bd_bif?
+		 */
 		if (d->bd_bif == NULL)
 			error = EINVAL;
 		else
@@ -804,6 +861,10 @@
 	 * Get interface name.
 	 */
 	case BIOCGETIF:
+		/*
+		 * XXXRW: Need to hold a mutex over test of bd_bif and then
+		 * dereferencing of it.
+		 */
 		if (d->bd_bif == NULL)
 			error = EINVAL;
 		else {
@@ -845,6 +906,10 @@
 		{
 			struct timeval *tv = (struct timeval *)addr;
 
+			/*
+			 * XXXRW: Need to hold a mutex over multiple reads to
+			 * prevent inconsistency.
+			 */
 			tv->tv_sec = d->bd_rtout / hz;
 			tv->tv_usec = (d->bd_rtout % hz) * tick;
 			break;
@@ -857,6 +922,10 @@
 		{
 			struct bpf_stat *bs = (struct bpf_stat *)addr;
 
+			/*
+			 * XXXRW: Need to hold a mutex over multiple reads to
+			 * prevent inconsistency.
+			 */
 			bs->bs_recv = d->bd_rcount;
 			bs->bs_drop = d->bd_dcount;
 			break;
@@ -914,20 +983,36 @@
 		break;
 
 	case FIOSETOWN:
+		/*
+		 * XXXRW: This is protected by sigio locking at the next
+		 * layer down, right?
+		 */
 		error = fsetown(*(int *)addr, &d->bd_sigio);
 		break;
 
 	case FIOGETOWN:
+		/*
+		 * XXXRW: This is protected by sigio locking at the next
+		 * layer down, right?
+		 */
 		*(int *)addr = fgetown(&d->bd_sigio);
 		break;
 
 	/* This is deprecated, FIOSETOWN should be used instead. */
 	case TIOCSPGRP:
+		/*
+		 * XXXRW: This is protected by sigio locking at the next
+		 * layer down, right?
+		 */
 		error = fsetown(-(*(int *)addr), &d->bd_sigio);
 		break;
 
 	/* This is deprecated, FIOGETOWN should be used instead. */
 	case TIOCGPGRP:
+		/*
+		 * XXXRW: This is protected by sigio locking at the next
+		 * layer down, right?
+		 */
 		*(int *)addr = -fgetown(&d->bd_sigio);
 		break;
 
@@ -953,6 +1038,10 @@
 /*
  * Set d's packet filter program to fp.  If this file already has a filter,
  * free it and replace it.  Returns EINVAL for bogus requests.
+ *
+ * XXXRW: There seem to be a number of races in here.  Perhaps the copyin and
+ * malloc should be done up front to make it easier to hold the lock over the
+ * duration?
  */
 static int
 bpf_setf(d, fp)
@@ -1010,6 +1099,10 @@
 	int error;
 	struct ifnet *theywant;
 
+	/*
+	 * XXXRW: While this might be more efficient, it does open the door
+	 * for more racing.
+	 */
 	theywant = ifunit(ifr->ifr_name);
 	if (theywant == NULL)
 		return ENXIO;
@@ -1034,6 +1127,10 @@
 		 * If we're already attached to requested interface,
 		 * just flush the buffer.
 		 */
+		/*
+		 * XXXRW: This section appears to be a bit racey.  Should it
+		 * be protected by the descriptor mutex?
+		 */
 		if (d->bd_sbuf == NULL) {
 			error = bpf_allocbufs(d);
 			if (error != 0)
@@ -1073,6 +1170,10 @@
 	struct bpf_d *d;
 	int revents;
 
+	/*
+	 * XXXRW: mutex should probably be grabbed before the test of bd_bif
+	 * or we might race.
+	 */
 	d = dev->si_drv1;
 	if (d->bd_bif == NULL)
 		return (ENXIO);
@@ -1110,6 +1211,10 @@
 	if (kn->kn_filter != EVFILT_READ)
 		return (1);
 
+	/*
+	 * XXXRW: Shouldn't we hold the bpf descriptor lock over this?  Or
+	 * maybe not.
+	 */
 	kn->kn_fop = &bpfread_filtops;
 	kn->kn_hook = d;
 	knlist_add(&d->bd_sel.si_note, kn, 0);
@@ -1123,6 +1228,9 @@
 {
 	struct bpf_d *d = (struct bpf_d *)kn->kn_hook;
 
+	/*
+	 * XXXRW: Anything extra locking-wise need to happen here?
+	 */
 	knlist_remove(&d->bd_sel.si_note, kn, 0);
 }
 
@@ -1134,6 +1242,9 @@
 	struct bpf_d *d = (struct bpf_d *)kn->kn_hook;
 	int ready;
 
+	/*
+	 * XXXRW: Wow, this locking actually looks mostly correct!
+	 */
 	BPFD_LOCK_ASSERT(d);
 	ready = bpf_ready(d);
 	if (ready) {
@@ -1168,6 +1279,9 @@
 	/*
 	 * Lockless read to avoid cost of locking the interface if there are
 	 * no descriptors attached.
+	 *
+	 * XXXRW: Is there a risk that the (bp) pointer here might become
+	 * invalid during or before dereference?
 	 */
 	if (LIST_EMPTY(&bp->bif_dlist))
 		return;
@@ -1229,6 +1343,8 @@
 	/*
 	 * Lockless read to avoid cost of locking the interface if there are
 	 * no descriptors attached.
+	 *
+	 * XXXRW: See bpf_tap() comment.
 	 */
 	if (LIST_EMPTY(&bp->bif_dlist))
 		return;
@@ -1275,6 +1391,8 @@
 	/*
 	 * Lockless read to avoid cost of locking the interface if there are
 	 * no descriptors attached.
+	 *
+	 * XXXRW: See bpf_tap() comment.
 	 */
 	if (LIST_EMPTY(&bp->bif_dlist))
 		return;
@@ -1292,6 +1410,10 @@
 
 	BPFIF_LOCK(bp);
 	LIST_FOREACH(d, &bp->bif_dlist, bd_next) {
+		/*
+		 * XXXRW: For test-and-set reasons, shouldn't bpf descriptor
+		 * be locked *before* this test?
+		 */
 		if (!d->bd_seesent && (m->m_pkthdr.rcvif == NULL))
 			continue;
 		BPFD_LOCK(d);
@@ -1324,7 +1446,12 @@
 {
 	struct bpf_hdr *hp;
 	int totlen, curlen;
-	int hdrlen = d->bd_bif->bif_hdrlen;
+	int hdrlen;
+
+	/*
+	 * XXXRW: Assert bpf descriptor lock here?
+	 */
+	hdrlen = d->bd_bif->bif_hdrlen;
 	int do_wakeup = 0;
 
 	BPFD_LOCK_ASSERT(d);
@@ -1387,6 +1514,9 @@
 
 /*
  * Initialize all nonzero fields of a descriptor.
+ *
+ * XXXRW: Shouldn't some sort of locking be going on here?  This can be
+ * called "live" by an ioctl().
  */
 static int
 bpf_allocbufs(d)
@@ -1467,6 +1597,11 @@
 	bp->bif_dlt = dlt;
 	mtx_init(&bp->bif_mtx, "bpf interface lock", NULL, MTX_DEF);
 
+	/*
+	 * XXXRW: Seems like this should really happen down at the bottom to
+	 * avoid exposing a mostly initialized bpf interface structure to the
+	 * world.
+	 */
 	mtx_lock(&bpf_mtx);
 	LIST_INSERT_HEAD(&bpf_iflist, bp, bif_next);
 	mtx_unlock(&bpf_mtx);
@@ -1498,6 +1633,12 @@
 	struct bpf_if	*bp;
 	struct bpf_d	*d;
 
+	/*
+	 * XXXRW: Check to make sure races between this code and other code
+	 * aren't too extreme.  In particular, that other code doesn't assume
+	 * that a descriptor will point to an interface in the global
+	 * interface list?
+	 */
 	/* Locate BPF interface information */
 	mtx_lock(&bpf_mtx);
 	LIST_FOREACH(bp, &bpf_iflist, bif_next) {
@@ -1516,6 +1657,12 @@
 	mtx_unlock(&bpf_mtx);
 
 	while ((d = LIST_FIRST(&bp->bif_dlist)) != NULL) {
+		/*
+		 * XXXRW: Should bpf descriptor lock be edged above the
+		 * detach call?  How come bpf_detachd() doesn't always
+		 * perform a wakeup?  Once detached, don't we risk a race with
+		 * wakeup()?
+		 */
 		bpf_detachd(d);
 		BPFD_LOCK(d);
 		bpf_wakeup(d);
@@ -1538,6 +1685,9 @@
 	struct ifnet *ifp;
 	struct bpf_if *bp;
 
+	/*
+	 * XXXRW: Assert descriptor lock here?  Why can't we use d->bd_bif?
+	 */
 	ifp = d->bd_bif->bif_ifp;
 	n = 0;
 	error = 0;
@@ -1572,6 +1722,10 @@
 	struct ifnet *ifp;
 	struct bpf_if *bp;
 
+	/*
+	 * XXXRW: Should acquire mutex earlier to prevent the ifnet from
+	 * changing out from under us?
+	 */
 	if (d->bd_bif->bif_dlt == dlt)
 		return (0);
 	ifp = d->bd_bif->bif_ifp;
@@ -1581,6 +1735,9 @@
 			break;
 	}
 	mtx_unlock(&bpf_mtx);
+	/*
+	 * XXXRW: Dropping the mutex here might open up a race?
+	 */
 	if (bp != NULL) {
 		opromisc = d->bd_promisc;
 		bpf_detachd(d);
--- //depot/vendor/freebsd/src/sys/net/if.c	2005/07/19 10:16:50
+++ //depot/user/rwatson/netperf/sys/net/if.c	2005/07/19 11:47:08
@@ -287,6 +287,14 @@
 	if_clone_init();
 }
 
+/*
+ * Grow the global ifindex_table by a power of two over the current side.
+ * Note that this call assumes ifindex_table (and hence the if_indexentry
+ * entries in it) can be relocated in memory without causing a problem.
+ *
+ * XXXRW: Locking assertion needed here?  What protects against untimely
+ * indirection through ifindex_table?  Note M_WAITOK.
+ */
 static void
 if_grow(void)
 {
@@ -303,6 +311,10 @@
 	ifindex_table = e;
 }
 
+/*
+ * if_check() scans the list of registered network interfaces to check that
+ * initialization-time invariants are met.
+ */
 /* ARGSUSED*/
 static void
 if_check(void *dummy __unused)
@@ -329,6 +341,19 @@
 	if_slowtimo(0);
 }
 
+/*
+ * if_findindex  ... XXXRW: what?
+ *
+ * Given a partially initialized ifnet reference, identify an available ifnet
+ * unit number that can be assigned to it.  Try searching for any user
+ * preferences or prior unit allocations; if there's no match or a collision,
+ * iterate through searching for the next available unit.  Note that the
+ * returned unit can be beyond the end of the index array, requiring the
+ * caller to extend the array by calling if_grow().
+ *
+ * XXXRW: Note that no reservation takes place, so as soon as the caller
+ * releases the lock, the unit returned may be reused.
+ */
 /* XXX: should be locked. */
 static int
 if_findindex(struct ifnet *ifp)
@@ -337,12 +362,18 @@
 	char eaddr[18], devname[32];
 	const char *name, *p;
 
+	IFNET_WASSERT();
+
 	switch (ifp->if_type) {
 	case IFT_ETHER:			/* these types use struct arpcom */
 	case IFT_FDDI:
 	case IFT_XETHER:
 	case IFT_ISO88025:
 	case IFT_L2VLAN:
+		/*
+		 * XXXRW: Assumes that arpcom always has its ifnet at the
+		 * head of its structure.
+		 */
 	case IFT_BRIDGE:
 		snprintf(eaddr, 18, "%6D", IFP2ENADDR(ifp), ":");
 		break;
@@ -453,6 +484,10 @@
 	struct sockaddr_dl *sdl;
 	struct ifaddr *ifa;
 
+	/*
+	 * XXXRW: Shouldn't we add to the global list only once the ifnet
+	 * is ready for use?
+	 */
 	if (ifp->if_index == 0 || ifp != ifnet_byindex(ifp->if_index))
 		panic ("%s: BUG: if_attach called without if_alloc'd input()\n",
 		    ifp->if_xname);
@@ -461,9 +496,6 @@
 	TASK_INIT(&ifp->if_linktask, 0, do_link_state_change, ifp);
 	IF_AFDATA_LOCK_INIT(ifp);
 	ifp->if_afdata_initialized = 0;
-	IFNET_WLOCK();
-	TAILQ_INSERT_TAIL(&ifnet, ifp, if_link);
-	IFNET_WUNLOCK();
 	/*
 	 * XXX -
 	 * The old code would work if the interface passed a pre-existing
@@ -484,6 +516,9 @@
 	mac_create_ifnet(ifp);
 #endif
 
+	IFNET_WLOCK();
+	TAILQ_INSERT_TAIL(&ifnet, ifp, if_link);
+	IFNET_WUNLOCK();
 	ifdev_byindex(ifp->if_index) = make_dev(&net_cdevsw,
 	    unit2minor(ifp->if_index),
 	    UID_ROOT, GID_WHEEL, 0600, "%s/%s",
@@ -557,6 +592,14 @@
 SYSINIT(domainifattach, SI_SUB_PROTO_IFATTACHDOMAIN, SI_ORDER_SECOND,
     if_attachdomain, NULL);
 
+/*
+ * XXXRW: if_attachdomain1() can only be called on an interface after it has
+ * an ifindex assigned, as IPv6 assumes that the index is allocated and will
+ * attempt to use it.
+ *
+ * XXXRW: How come we need to check for multiple attachments of domain-
+ * specific data?
+ */
 static void
 if_attachdomain1(struct ifnet *ifp)
 {
@@ -2155,10 +2198,38 @@
 }
 
 int
+ifq_handoff(struct ifnet *ifp, struct mbuf *m, int adjust)
+{
+	int error, len;
+	short mflags;
+
+	if (ifp->if_start_mbuf != NULL) {
+		if (ifp->if_start_mbuf(ifp, m, adjust))
+			return (0);
+		else
+			return (ENOBUFS);
+	}
+
+	len = m->m_pkthdr.len;
+	mflags = m->m_flags;
+	IFQ_ENQUEUE(&ifp->if_snd, m, error);
+	if (error)
+		return (error);
+	ifp->if_obytes += len + adjust;
+	if (mflags & M_MCAST)
+		ifp->if_omcasts++;
+	if ((ifp->if_flags & IFF_OACTIVE) == 0)
+		if_start(ifp);
+	return (0);
+}
+
+int
 if_handoff(struct ifqueue *ifq, struct mbuf *m, struct ifnet *ifp, int adjust)
 {
 	int active = 0;
 
+	if (ifp != NULL && ifp->if_start_mbuf != NULL)
+		return (ifp->if_start_mbuf(ifp, m, adjust));
 	IF_LOCK(ifq);
 	if (_IF_QFULL(ifq)) {
 		_IF_DROP(ifq);
--- //depot/vendor/freebsd/src/sys/net/if_ethersubr.c	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/net/if_ethersubr.c	2005/07/05 14:55:33
@@ -634,9 +634,6 @@
 		if ((m = bridge_in_ptr(ifp, m)) == NULL)
 			return;
 
-	/* First chunk of an mbuf contains good entropy */
-	if (harvest.ethernet)
-		random_harvest(m, 16, 3, 0, RANDOM_NET);
 	ether_demux(ifp, m);
 }
 
--- //depot/vendor/freebsd/src/sys/net/if_gif.c	2005/06/26 18:15:33
+++ //depot/user/rwatson/netperf/sys/net/if_gif.c	2005/07/05 14:55:33
@@ -89,6 +89,10 @@
  * gif_mtx protects the global gif_softc_list.
  * XXX: Per-softc locking is still required.
  */
+/*
+ * XXXRW: Note that gif_mtx only protects global gif-related data, not
+ * per-softc data.  See also netinet/in_gif.c for locking needs.
+ */
 static struct mtx gif_mtx;
 static MALLOC_DEFINE(M_GIF, "gif", "Generic Tunnel Interface");
 static LIST_HEAD(, gif_softc) gif_softc_list;
@@ -513,6 +517,9 @@
 }
 
 /* XXX how should we handle IPv6 scope on SIOC[GS]IFPHYADDR? */
+/*
+ * XXXRW: per-gif softc locking required.
+ */
 int
 gif_ioctl(ifp, cmd, data)
 	struct ifnet *ifp;
@@ -769,8 +776,10 @@
 	int s;
 	int error = 0; 
 
+	/*
+	 * XXXRW: per-gif softc locking required.
+	 */
 	s = splnet();
-
 	mtx_lock(&gif_mtx);
 	LIST_FOREACH(sc2, &gif_softc_list, gif_list) {
 		if (sc2 == sc)
@@ -799,6 +808,9 @@
 	}
 	mtx_unlock(&gif_mtx);
 
+	/*
+	 * XXXRW: Lock gif softc fields.
+	 */
 	/* XXX we can detach from both, but be polite just in case */
 	if (sc->gif_psrc)
 		switch (sc->gif_psrc->sa_family) {
--- //depot/vendor/freebsd/src/sys/net/if_gre.c	2005/06/28 07:00:51
+++ //depot/user/rwatson/netperf/sys/net/if_gre.c	2005/07/05 14:55:33
@@ -95,7 +95,8 @@
 
 /*
  * gre_mtx protects all global variables in if_gre.c.
- * XXX: gre_softc data not protected yet.
+ *
+ * XXXRW: It does not protect softc-specific data.
  */
 struct mtx gre_mtx;
 static MALLOC_DEFINE(M_GRE, GRENAME, "Generic Routing Encapsulation");
--- //depot/vendor/freebsd/src/sys/net/if_gre.h	2005/06/10 16:51:34
+++ //depot/user/rwatson/netperf/sys/net/if_gre.h	2005/07/05 14:55:33
@@ -54,6 +54,12 @@
 	WCCP_V2
 } wccp_ver_t;
 
+/*
+ * XXXRW: softc fields need locking.
+ *
+ * XXXRW: gre's notion of a 'called' count is not MP-safe, as it assumes
+ * only one packet can be processed at a time.
+ */
 struct gre_softc {
 	struct ifnet *sc_ifp;
 	LIST_ENTRY(gre_softc) sc_list;
